LeetCode in Kotlin

803. Bricks Falling When Hit

Hard

You are given an m x n binary grid, where each 1 represents a brick and 0 represents an empty space. A brick is stable if:

You are also given an array hits, which is a sequence of erasures we want to apply. Each time we want to erase the brick at the location hits[i] = (rowi, coli). The brick on that location (if it exists) will disappear. Some other bricks may no longer be stable because of that erasure and will fall. Once a brick falls, it is immediately erased from the grid (i.e., it does not land on other stable bricks).

Return an array result, where each result[i] is the number of bricks that will fall after the ith erasure is applied.

Note that an erasure may refer to a location with no brick, and if it does, no bricks drop.

Example 1:

Input: grid = [[1,0,0,0],[1,1,1,0]], hits = [[1,0]]

Output: [2]

Explanation: Starting with the grid:

[[1,0,0,0], [1,1,1,0]]

We erase the underlined brick at (1,0), resulting in the grid:

[[1,0,0,0], [0,1,1,0]]

The two underlined bricks are no longer stable as they are no longer connected to the top nor adjacent to another stable brick, so they will fall. The resulting grid is:

[[1,0,0,0], [0,0,0,0]]

Hence the result is [2].

Example 2:

Input: grid = [[1,0,0,0],[1,1,0,0]], hits = [[1,1],[1,0]]

Output: [0,0]

Explanation: Starting with the grid:

[[1,0,0,0], [1,1,0,0]]

We erase the underlined brick at (1,1), resulting in the grid:

[[1,0,0,0], [1,0,0,0]]

All remaining bricks are still stable, so no bricks fall. The grid remains the same:

[[1,0,0,0], [1,0,0,0]]

Next, we erase the underlined brick at (1,0), resulting in the grid:

[[1,0,0,0], [0,0,0,0]]

Once again, all remaining bricks are still stable, so no bricks fall.

Hence the result is [0,0].

Constraints:

Solution

class Solution {
    private val dirs = arrayOf(intArrayOf(1, 0), intArrayOf(-1, 0), intArrayOf(0, 1), intArrayOf(0, -1))
    fun hitBricks(grid: Array<IntArray>, hits: Array<IntArray>): IntArray {
        val cols = grid[0].size
        for (hit in hits) {
            val x = hit[0]
            val y = hit[1]
            grid[x][y]--
        }
        val row = 0
        for (col in 0 until cols) {
            dfs(row, col, grid)
        }
        val res = IntArray(hits.size)
        for (i in hits.indices.reversed()) {
            val x = hits[i][0]
            val y = hits[i][1]
            grid[x][y]++
            if (grid[x][y] == 1 && isConnectedToRoof(x, y, grid)) {
                res[i] = dfs(x, y, grid) - 1
            }
        }
        return res
    }

    private fun dfs(i: Int, j: Int, grid: Array<IntArray>): Int {
        if (i < 0 || i >= grid.size || j < 0 || j >= grid[0].size || grid[i][j] != 1) {
            return 0
        }
        grid[i][j] = 2
        return (
            dfs(i + 1, j, grid) +
                dfs(i - 1, j, grid) +
                dfs(i, j + 1, grid) +
                dfs(i, j - 1, grid) +
                1
            )
    }

    private fun isConnectedToRoof(i: Int, j: Int, grid: Array<IntArray>): Boolean {
        if (i == 0) {
            return true
        }
        for (d in dirs) {
            val x = i + d[0]
            val y = j + d[1]
            if (x >= 0 && x < grid.size && y >= 0 && y < grid[0].size && grid[x][y] == 2) {
                return true
            }
        }
        return false
    }
}